#include <bits/stdc++.h>
#define ll long long

using namespace std;

vector<bool> used;
ll mod = 1e9 + 7;

ll f(int n, ll num) {
    if (n == 0) {
        return 1;
    }
    vector<vector<ll>> dp(n + 1, vector<ll> (9, 0));
    ll sum = 0;
    for (int i = 1; i <= 8; i++) {
        if (used[i]) {
            dp[1][i] = 1;
            if (i != num) {
                sum = (sum % mod + 1) % mod;
            }
        }
    }
    for (int i = 2; i <= n; i++) {
        for (int j = 1; j <= 8; j++) {
            if (used[j] && num != j) {
                if (i - j >= 1) {
                    dp[i][j] = (dp[i][j] % mod + dp[i - j][j] % mod) % mod;
                    for (int k = 1; k <= 8; k++) {
                        if (k != j && used[k] && num != k) {
                            dp[i][j] = (dp[i][j] % mod + dp[i - j][k] % mod) % mod;
                        }
                    }
                } else {
                    dp[i][j] = 1;
                }
                dp[i][j] = (dp[i][j] % mod * f(j - 1, j) % mod) % mod;
            }
        }
    }
    return sum;
}

int main() {
    int n, m;
    int num;
    cin >> n >> m;
    used.resize(9, false);
    vector<vector<ll> > dp(n + 1, vector<ll> (9, 0));
    for (int i = 0; i < m; i++) {
        cin >> num;
        dp[1][num] = 1;
        used[num] = true;
    }
    for (int i = 2; i <= n; i++) {
        for (int j = 1; j <= 8; j++) {
            if (used[j]) {
                if (i - j >= 1) {
                    dp[i][j] = (dp[i][j] % mod + dp[i - j][j] % mod) % mod;
                    for (int k = 1; k <= 8; k++) {
                        if (k != j && used[k]) {
                            dp[i][j] = (dp[i][j] % mod + dp[i - j][k] % mod) % mod;
                        }
                    }
                } else {
                    dp[i][j] = 1;
                }
                dp[i][j] = (dp[i][j] % mod * f(j - 1, j) % mod) % mod;
            }
        }
    }
    ll sum = 0;
    for (int i = 1; i <= 8; i++) {
        sum = (sum % mod + dp[n][i] % mod) % mod;
    }
    cout << sum;
    return 0;
}
